								;ਫ 2

          Title  "Lab Program"
          ;
          list p=16c74    ; processor type
          errorlevel          1, -(305)
          ;
	  #include "p16c74.inc"
          ;
Stat1	equ	20h
Takt	equ	21h
CntByte	equ	22h
Shif	equ	23h
RxBuf	equ	24h
CntShi	equ	25h
ByteX	equ	26h
ByteY	equ	27h

          org 00h
	;  릮
	movlw	0
	movwf	PCLATH
	goto	Start

	org	04h	; 뢠
	nop

	org	100h	; ணࠬ ஢
Start	; 砫쭠 ⠭
	call	ConstInit

DirBD	; ன ࠢ RB, RD
	bsf	STATUS,RP0
	movlw	b'11111111'	; RB input	
	movwf	TRISB
	movlw	b'11011001'	; RD.5, RD.2, RD.1 output 
        movwf	TRISD
	bcf	STATUS,RP0

BegUst	movlw	b'11111001' ; R=0, C=1, EC=0
	movwf	PORTD
	bsf	PORTD,2	    ; R=1
	bcf	PORTD,2     ; R=0

	goto	Answer 	

Priem
	call	Receiv
	movlw	2
	xorwf	PORTA,f

	;    
Pusk	bcf	PORTE,2  ; CLR=0
	bsf	PORTC,1  ; U0=1
	bsf	PORTC,2  ; U1=1
	bsf	PORTC,0  ; RD=1
	bsf	PORTE,2  ; CLR=1

Command
	movf	RxBuf,w
	xorlw	'r'
	btfsc	STATUS,Z
	goto	BegUst	    

	movf	RxBuf,w
	xorlw	'i'
	btfsc	STATUS,Z
	goto	Increm

	goto 	Priem

Increm
	bcf	PORTD,5	; C = 0;
	bsf	PORTD,5 ; C = 1;
	goto	Answer

Answer ; 뤠 PORTD, PORTB 
	movf	PORTD,w
	call	Transm
	movf	PORTB,w
	call	Transm

	; ࠧ襭 CLKU
	movlw	b'11111001'
	andwf	PORTC,f     ; U1=0, U0=0
	bcf	PORTC,0     ; RD=0

	; ⥭   뤠 6 
	movlw	3
	movwf	CntByte
RdTrans
	call	RdAlt
	movf	ByteX,w
	call	Transm
	movf	ByteY,w
	call	Transm
	decfsz	CntByte
	goto	RdTrans

	goto	Priem

ConstInit
	bsf	STATUS,RP0
	movlw	b'10000000' ; RC7/RX in
	movwf	TRISC
	movlw	b'111100'   ; RA0,RA1 out diod
	movwf	TRISA
	movlw	b'011' 	    ; CLR out
	movwf	TRISE
	movlw	d'129'
	movwf	SPBRG
	movlw	b'00100100'
	movwf	TXSTA
 
	bcf	STATUS,RP0
	clrf	INTCON
	clrf	PORTC
	movlw	b'10010000'
	movwf	RCSTA
	return

Receiv  ; ਥ 
	clrf 	STATUS	  ; Bank 0
RecA    btfss 	PIR1,RCIF ; check for received data
        goto 	RecA
RecB    movf 	RCREG,w
	movwf 	RxBuf
        return

Transm	; 뤠
	clrf 	STATUS
        movwf 	TXREG     ; transmit byte to PC
	bcf	PIR1,TXIF
tr3	btfss 	PIR1,TXIF
	goto 	tr3
	return

RdAlt 	; ⥭ 2  
	movlw	8
	movwf	Shif

Rd1	bcf	STATUS,C
	btfsc	PORTE,0
	bsf	STATUS,C
	rlf	ByteX,f

	bcf	STATUS,C
	btfsc	PORTE,1
	bsf	STATUS,C
	rlf	ByteY,f

	bsf	PORTC,3
	bcf	PORTC,3    ; CLKU=1,0
	decfsz	Shif
	goto	Rd1
	return

	end
