          Title  "Lab Program"
          ;
          list p=16c74    ; processor type
          errorlevel          1, -(305)
          ;
	  #include "p16c74.inc"
          ;
Stat1	equ	20h
Takt	equ	21h
CntByte	equ	22h
Shif	equ	23h
RxBuf	equ	24h
CntShi	equ	25h
ByteX	equ	26h
ByteY	equ	27h


          org 00h
	;  릮
	movlw	0
	movwf	PCLATH
	goto	Start

	org	04h	; 뢠
	nop

	org	100h	; ணࠬ ஢
Start	; 砫쭠 ⠭
	call	ConstInit

DirBD	; ன ࠢ RB, RD
	bsf	STATUS,RP0
	movlw	b'00111111';  
	movwf	TRISB
	movlw	b'10011111'; 
        movwf	TRISD

	bcf	STATUS,RP0

BegUst	movlw	b'11111111' ; C+=1 C-=1
	movwf	PORTB
	movlw	b'11011111' ; PE/=1 R=0
	movwf	PORTD
	bcf	PORTD,6	    ; R=1
	bsf	PORTD,6     ; R=0

	goto	Answer 	

Priem
	call	Receiv
	movlw	2
	xorwf	PORTA,f

	;    
Pusk	bcf	PORTC,5  ; CLR=0
	bsf	PORTC,1  ; U0=1
	bsf	PORTC,2  ; U1=1
	bsf	PORTC,0  ; RD=1
	bsf	PORTC,5  ; CLR=1

Command
	movf	RxBuf,w
	xorlw	'r'
	btfsc	STATUS,Z
	goto	BegUst	    

	movf	RxBuf,w
	xorlw	'i'
	btfsc	STATUS,Z
	goto	Increm

	movf	RxBuf,w
	xorlw	'd'
	btfsc	STATUS,Z
	goto	Decrem

	goto 	Priem

Increm 	nop
        bsf	PORTD,5
	nop
	bcf	PORTD,5
	goto	Answer

Decrem 	bcf	PORTB,7
	goto	Increm

	 nop
	goto	Answer

Answer ; 뤠 PORTD, PORTB 
	movf	PORTD,w
	call	Transm
	movf	PORTB,w
	call	Transm

	; ࠧ襭 CLKU
	movlw	b'11111001'
	andwf	PORTC,f     ; U1=0, U0=0
	bcf	PORTC,0    ; RD=0

	; ⥭   뤠 6 
	movlw	3
	movwf	CntByte
RdTrans
	call	RdAlt
	movf	ByteX,w
	call	Transm
	movf	ByteY,w
	call	Transm
	decfsz	CntByte
	goto	RdTrans

	goto	Priem

ConstInit
	bsf	STATUS,RP0
	movlw	b'10000000' ; RC7/RX in
	movwf	TRISC
	movlw	b'111100' ; RA0,RA1 out diod
	movwf	TRISA
	movlw	b'011' 	; CLR out
	movwf	TRISE
;	movlw	b'10000011'
;	movwf	OPTION_REG
;	movlw	129
;	movwf	SPBRG
;	movlw	b'00100100'
;	movwf	TXSTA
 
	bcf	STATUS,RP0
	clrf	INTCON
	clrf	PORTC
;	movlw	b'10010000'
;	movwf	RCSTA
	return

Receiv  ; ਥ 
	clrf 	STATUS	  ; Bank 0
RecA    btfss 	PIR1,RCIF ; check for received data
        goto 	RecA
RecB    movf 	RCREG,w
	movwf 	RxBuf
        return

Transm	; 뤠
	clrf 	STATUS
        movwf 	TXREG     ; transmit byte to PC
	bcf	PIR1,TXIF
tr3	btfss 	PIR1,TXIF
	goto 	tr3
	return

RdAlt 	; ⥭ 2  
	movlw	8
	movwf	Shif

Rd1	bcf	STATUS,C
	btfsc	PORTE,0
	bsf	STATUS,C
	rlf	ByteX,f

	bcf	STATUS,C
	btfsc	PORTE,1
	bsf	STATUS,C
	rlf	ByteY,f

	bsf	PORTC,3
	bcf	PORTC,3    ; CLKU=0,1,0
	decfsz	Shif
	goto	Rd1
	return

	end
